<template>
    <table class="table">
        <thead>
            <tr>
                <th>Label</th>
                <th>Due date</th>
                <th>User</th>
                <th>Status</th>
                <th>Operations</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="task in tasks" v-bind:data-id="task.id">
                <td>
                    <a v-bind:href="'/tasks/' + task.id">{{ task.label }}</a>
                </td>
                <td>
                    {{ task.dueDate }}
                </td>
                <td>
                    {{ task.user.name }}
                </td>
                <td>
                    {{ task.status }}
                </td>
                <td>
                    <a class="badge badge-secondary badge-pill" v-bind:href="'tasks/' + task.id + '/edit/'">Edit</a>
                    <button class="btn btn-light" v-on:click="deleteEntry">
                        Delete
                    </button>
                </td>
            </tr>
        </tbody>
    </table>
</template>

<script>
const { default: Axios } = require('axios');

export default {
    data () {
        return {
            tasks: null
        }
    },
    mounted () {
        Axios
            .get('api/tasks')
            .then(response => (this.tasks = response.data))
    },
    methods: {
        deleteEntry: function(event) {
            event.preventDefault();
            event.stopPropagation();
            console.log('delete event');
            Axios
                .delete('api/tasks/' + $(event.target).closest('tr').data('id'))
                .then($(event.target).closest('tr').remove());
            console.log('task deleted');
        }
    }
}
</script>